<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Models;
use App\Http\Base\BaseModel;
use Carbon\Carbon;

class SystemparameterModel extends BaseModel
{
    /**
     * table name from database
     */
    protected $table="systemparameter";

    /**
     *   alias table for relation issues
     */
    protected $aliasTable="systemparameter";

	/**
	* primary key from table remember eloquent doesnt support composite primary key
	*/
	protected $primaryKey = "id";
	/**
	* fillable property for eloquent attribute cast
	*/
	protected $fillable=[
		"variableValue", "date_updated"
	];
	/**
	* Creating raw object from table that, this purpose for making you easier for remembering all attribute
	*/


    /**
     * paging for default paging purpose
     * if you want to add new paging property you have to add the property in this array
     * you have to add the relation value
     * remember this is not suported casting value you have to handle by your self
    */
	protected $aliasPaging = [
		"variableName" => "systemparameter.variableName",
		"id" => "systemparameter.id",
		"variableValue" => "systemparameter.variableValue",
	];

	public static function storeFromHO($data)
    {

        $model = (new self())->getQuery()->where("systemparameter.id", "=", $data->id)->first();
        if ($model) {
            $model = self::find($model->id);
            $model->id = $data->id;
			$model->variableName = $data->variableName;
			$model->variableValue = $data->variableValue;
            $model->date_updated = $data->date_updated;
            $model->update();
            (new LogsynckapalModel)->setLogSync("System Parameters : ".$data->id." - ".$data->variableName." - ".$data->variableName, Carbon::now()->toDateTimeString(), "", "updated");
        } else {
            $model = new self();
            $model->id = $data->id;
            $model->variableName = $data->variableName;
			$model->variableValue = $data->variableValue;
            $model->date_updated = $data->date_updated;
            $model->save([], $data->id, 0);
            (new LogsynckapalModel)->setLogSync("System Parameters : ".$data->id." - ".$data->variableName." - ".$data->variableName, Carbon::now()->toDateTimeString(), "", "inserted");
        }
        echo $data->variableName . " sync", PHP_EOL;
    }

    public static function getSystemParameter()
    {
        $url = $GLOBALS["env"]["HEAD_OFFICE_URL"] . "/api/sync_system_parameter";
        $syncTable = (new \App\Http\Models\SyncUtilities\SyncTableHandlerModel())->getQuery()->where("sync_table.id", "=", 19)->first();
        $fetch = true;
        $page = 1;
        (new LogsynckapalModel)->setLogSync("System Parameters HO to Kapal", Carbon::now()->toDateTimeString(), "", "start");
        do {
            if ($syncTable) {

                $lastUpdate = Carbon::parse($syncTable->last_sync)->toAtomString();
                $lastUpdate = !empty($syncTable->last_sync) ? \Carbon\Carbon::parse($syncTable->last_sync)->toAtomString() : $lastUpdate;
                $url = $url . "?date_updated=" . $lastUpdate . "&page=" . $page;
                $syncHandler = new \App\Http\Handler\CurlHandler();
                try {
                    $response = $syncHandler->setUrl($url)->send();
                    $res = json_decode($response, false);
                    $no = 1;
                    if (!empty($res->data)) {
                        if($page == 1) {
                            \App\Http\Models\SystemparameterModel::truncate();
                        }
                        foreach ($res->data as $item) {
                            echo "data " . $no;
                            \App\Http\Models\SystemparameterModel::storeFromHO($item);
                            $lastUpdate = $item->date_updated;
                            $no = $no + 1;
                        }
                        $sync = \App\Http\Models\SyncUtilities\SyncTableHandlerModel::find($syncTable->id);
                        $sync->last_sync = $lastUpdate;
                        $sync->update();
                    } else $fetch = false;

                } catch (\Exception $e) {
                    echo $e->getMessage();
                    (new LogsynckapalModel)->setLogSync("System Parameters HO to Kapal", Carbon::now()->toDateTimeString(), $e->getMessage(), "failed");
                }
                $page = $page + 1;
            }
        } while ($fetch);
        (new LogsynckapalModel)->setLogSync("System Parameters HO to Kapal", Carbon::now()->toDateTimeString(), "", "success");
    }

}